%define oname		cprops

%define major		15
%define libname		%mklibname %{oname} %{major}
%define develname	%mklibname -d %{oname}

%define dbms_major	0
%define mysqllib	%mklibname cp_dbms_mysql %{dbms_major}
%define pgreslib	%mklibname cp_dbms_postgres %{dbms_major}

%bcond_without	postgres
%bcond_without	mysql

Name:		lib%{oname}
Version:	0.1.12
Release:	%mkrel 6

Summary:	C Prototyping Tools
Group:		Development/C
License:	LGPLv2+
URL:		http://%{oname}.sourceforge.net/
Source0:	http://downloads.sourceforge.net/%{oname}/%{name}-%{version}.tar.bz2
Patch0:		libcprops-AC_DEFINE.patch
Patch1:		libcprops-format-string.patch

BuildRequires:	openssl-devel
BuildRequires:	flex
BuildRequires:	bison

%description
The C Prototyping Tools library provides thread-safe linked list, priority
queue, hash table, hash list, AVL tree and trie implementations, as well
as a thread pool and a thread management framework, a TCP and an HTTP socket
API, and a DBMS abstraction layer.

%package -n %{libname}
Summary:	C Prototyping Tools
Group:		System/Libraries
Obsoletes:	%{_lib}libcprops0 < 0.1.12-3

%if %with mysql
%package -n %{mysqllib}
Summary:	MySQL (MariaDB) dbms driver for %{name}
Group:		System/Libraries
BuildRequires:	mysql-devel

%description -n %{mysqllib}
This package contains the MySQL (MariaDB) dbms driver for %{name}.
%endif

%if %with postgres
%package -n %{pgreslib}
Summary:	PostgreSQL dbms driver for %{name}
Group:		System/Libraries
BuildRequires:	postgresql-devel
Conflicts:	%{_lib}libcprops0 < 0.1.12-3

%description -n %{pgreslib}
This package contains the PostgreSQL dbms driver for %{name}.
%endif

%description -n %{libname}
The C Prototyping Tools library provides thread-safe linked list, priority
queue, hash table, hash list, AVL tree and trie implementations, as well
as a thread pool and a thread management framework, a TCP and an HTTP socket
API, and a DBMS abstraction layer.

%package -n %{develname}
Summary:	Development files for %{name}
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Obsoletes:	%{_lib}libcprops-devel < 0.1.12-3

%description -n %{develname}
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%prep
%setup -q
%apply_patches

# for autoreconf
mkdir -p m4

%build
autoreconf -vfi
%configure2_5x \
	--disable-static \
	--disable-cpsvc \
	--disable-cpsp \
	--enable-shared \
	--with-ssl=%{_prefix} \
	%{?with_postgres:--with-postgres-includes=%{_includedir}/pgsql} \
	%{?with_postgres:--with-postgres-libs=%{_libdir}} \
	%{?with_mysql:--with-mysql-includes=%{_includedir}/mysql} \
	%{?with_mysql:--with-mysql-libs=%{_libdir}}

sed -e 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' \
    -e 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' \
    -e 's|func_apped|func_append|' \
    -e 's|CC -shared|CC -shared -Wl,--as-needed|g' \
    -i libtool

%make

%install
%makeinstall_std

# we don't want these
find %{buildroot} -name "*.la" -delete

%files -n %{libname}
%doc README ChangeLog
%{_libdir}/%{name}.so.%{major}
%{_libdir}/%{name}.so.%{major}.*

%if %with mysql
%files -n %{mysqllib}
%{_libdir}/libcp_dbms_mysql.so.%{dbms_major}
%{_libdir}/libcp_dbms_mysql.so.%{dbms_major}.*
%endif

%if %with postgres
%files -n %{pgreslib}
%{_libdir}/libcp_dbms_postgres.so.%{dbms_major}
%{_libdir}/libcp_dbms_postgres.so.%{dbms_major}.*
%endif

%files -n %{develname}
%{_mandir}/man3/*
%{_includedir}/%{oname}/
%{_libdir}/*.so


%changelog
* Sat Oct 19 2013 umeabot <umeabot> 0.1.12-6.mga4
+ Revision: 528200
- Mageia 4 Mass Rebuild

* Sun Jun 16 2013 wally <wally> 0.1.12-5.mga4
+ Revision: 443755
- build dbms drivers

* Sun Jun 16 2013 wally <wally> 0.1.12-4.mga4
+ Revision: 443689
- obsolete wrongly named devel pkg

* Sun Jun 16 2013 wally <wally> 0.1.12-3.mga4
+ Revision: 443672
- fix libification
- disable postgres build for now
- add patch to fix build when using autoreconf
- clean .spec a bit

* Sat Jan 12 2013 umeabot <umeabot> 0.1.12-2.mga3
+ Revision: 356928
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Dec 15 2012 shlomif <shlomif> 0.1.12-1.mga3
+ Revision: 331213
- Made the package more Mageia-like
- import based on the Fedora RawHide package.


* Tue Jan 31 2012 Philip Prindeville <philipp@fedoraproject.org> 0.1.12-1.1
 - Fix build issues on EL6 with older libtool.

* Mon Jan 23 2012 Philip Prindeville <philipp@fedoraproject.org> 0.1.12-1
 - Version bump which fixes "library calling exit()" warning from rpmlint.

* Mon Jan 09 2012 Philip Prindeville <philipp@fedoraproject.org> 0.1.11-1
 - Fix review comments.

* Fri Dec 09 2011 Philip Prindeville <philipp@fedoraproject.org> 0.1.10-0.1
 - Enable trie module.

* Thu Nov 10 2011 Philip Prindeville <philipp@fedoraproject.org> svn36-0.1
 - Fixes for documentation warnings.
 - Fixes for compiler warnings.

* Sun Oct 30 2011 Philip Prindeville <philipp@fedoraproject.org> 0.1.8-0.1
 - Initial packaging.
